require 'much-plugin'

require 'mr/after_commit/fake_record'
require 'mr/after_commit/record'
require 'mr/after_commit/record_procs_methods'
require 'mr/model'

module MR

  module AfterCommit
    include MuchPlugin

    # demeter these constants so they are available from the `MR::AfterCommit`
    # namespace
    VALID_CALLBACK_TYPES  = RecordProcsMethods::VALID_CALLBACK_TYPES
    DEFAULT_CALLBACK_TYPE = RecordProcsMethods::DEFAULT_CALLBACK_TYPE

    plugin_included do
      include MR::Model
      include InstanceMethods
    end

    module InstanceMethods

      def after_commit_procs(*args)
        self.record.after_commit_procs(*args)
      end

      def after_commit(on = nil, &block)
        self.record.add_after_commit_proc(on, &block)
      end

      def prepend_after_commit(on = nil, &block)
        self.record.prepend_after_commit_proc(on, &block)
      end

      def clear_after_commit_procs(*args)
        self.record.clear_after_commit_procs(*args)
      end

      def called_after_commit_procs(*args)
        self.record.called_after_commit_procs(*args)
      end

    end

  end

end
