require 'much-plugin'

require 'mr/after_commit/record_procs_methods'
require 'mr/fake_record'

module MR; end
module MR::AfterCommit

  module FakeRecord
    include MuchPlugin

    plugin_included do
      include MR::FakeRecord
      include RecordProcsMethods
      include InstanceMethods
    end

    module InstanceMethods

      def save!
        is_new = self.new_record?
        super.tap do
          callback_type = is_new ? :create : :update
          mr_after_commit_call_procs(callback_type)
          mr_after_commit_call_procs(:save)
        end
      end

      def destroy
        super.tap do
          mr_after_commit_call_procs(:destroy)
        end
      end

    end

  end

end
