require 'much-plugin'

require 'mr/fake_record'

module MR; end
module MR::JsonField

  module FakeRecord
    include MuchPlugin

    plugin_included do
      include MR::FakeRecord
      include InstanceMethods
    end

    module InstanceMethods

      # this mimics the `JsonField::Record` mixin, doing the same logic to
      # ensure that the source fields match the json fields
      def save!
        self.model.class.json_field_accessors.each do |field_name|
          self.model.send("#{field_name}=", self.model.send(field_name))
        end
        super
      end

    end

  end

end
